/*****************************************************************************
 
            Copyright (c)94-98 Geovariances, Avon, France.
 
    In consideration  of payment of  the license fee,  which is a part of
    the price you  paid for this  product, Geovariances (GV) as licensor,
    grants you, the licensee, a non-exclusive right to use this copy of a
    GV software product.
    GV reserves all rights not  expressly granted to licensee. GV retains
    titleship and ownership  of software.  This license is not  a sale of
    the original  software or any  copy. GV also  retains  titleship  and
    ownership of any modifications or  derivations of this software.  Any
    modifications of this software  must be clearly marked as such.  This
    copyright message must  appear in its entirety  in this software,  or
    any modifications or derivations thereof.
 
    Geovariances welcomes any comments, suggestions, bug reports, etc. At
    the discretion  of Geovariances,  any customer  supplied  bug  fixes,
    enhancements, or utility codes will be distributed in future software
    releases (the contributor will of course be credited).
 
            Geovariances
            38, Avenue Franklin Roosevelt
            77210 Avon, FRANCE
 
             Phone: +33-(0)-160.749.100
               Fax: +33-(0)-164.228.728
            e-mail: support@geovariances.fr
 
                        All Rights Reserved
 
*****************************************************************************/

#ifndef _GTXOs_h
#define _GTXOs_h

#undef GTX_EXE_64
#undef GTX_BIG_ENDIAN
#undef GTX_LITTLE_ENDIAN
#define GTXLONG_FORMAT "ld"
#define GTXULONG_FORMAT "lu"

#if defined(__sparc) && defined(__sun) && defined(__SVR4)
# define ARCH "solaris"
# ifndef solaris
#  define solaris
# endif
# ifndef __EXTENSIONS__
#  define __EXTENSIONS__ 1
# endif
# define GTX_BIG_ENDIAN
# ifdef __sparcv9
#  define GTX_EXE_64
#  define GTX_ARCH_FOUND "solaris64"
# else
#  define GTX_ARCH_FOUND "solaris"
# endif
typedef long gtx_long;
typedef unsigned long gtx_ulong;
#endif
 
#if defined(_MIPSEB) && defined(__sgi) && defined(__mips)
# define ARCH "irix"
# ifndef irix
#  define irix
# endif
# define GTX_BIG_ENDIAN
# if (_MIPS_SZPTR == 64)
#  define GTX_EXE_64
#  define GTX_ARCH_FOUND "irix64"
# else
#  define GTX_ARCH_FOUND "irix"
# endif
typedef long gtx_long;
typedef unsigned long gtx_ulong;
#endif
 
#if defined(_WIN32)
# define ARCH "winnt"
# ifndef winnt
#  define winnt
# endif
# define GTX_LITTLE_ENDIAN
# ifdef _WIN64
#  define GTX_EXE_64
#  undef gtx_long
#  undef GTXLONG_FORMAT
#  undef GTXULONG_FORMAT
typedef __int64 gtx_long;
typedef unsigned __int64 gtx_ulong;
#  define GTXLONG_FORMAT "I64d"
#  define GTXULONG_FORMAT "I64u"
#  define GTX_ARCH_FOUND "winnt64"
# else
#  define GTX_ARCH_FOUND "winnt"
typedef long gtx_long;
typedef unsigned long gtx_ulong;
# endif
#endif

#if (defined (__i386__) || defined(__x86_64__)) && defined(__linux__) 
# define ARCH "linux"
# ifndef linux
#  define linux
# endif
# define GTX_LITTLE_ENDIAN
# ifdef __x86_64__
#  define GTX_EXE_64
#  define GTX_ARCH_FOUND "linux64"
# else
#  define GTX_ARCH_FOUND "linux"
# endif
typedef long gtx_long;
typedef unsigned long gtx_ulong;
#endif

#ifndef GTX_ARCH
#  define GTX_ARCH GTX_ARCH_FOUND
#endif

#if defined(GTX_DLL)
#define USE_SHARED_gtxclient
#endif

#if defined(winnt) && defined(USE_SHARED_gtxclient)
# define GLOBAL __declspec(dllimport)
#else
# define GLOBAL extern
#endif

#if defined(winnt) && defined(USE_SHARED_gtxclient)
# define GLOBAL_CLASS __declspec(dllimport)
#elif defined(winnt) && defined(MAKE_SHARED_gtxclient)
# define GLOBAL_CLASS __declspec(dllexport)
#else
# define GLOBAL_CLASS
#endif

#endif /* !_GTXOs_h_ */
