/*****************************************************************************
 
            Copyright (c)94-98 Geovariances, Avon, France.
 
    In consideration  of payment of  the license fee,  which is a part of
    the price you  paid for this  product, Geovariances (GV) as licensor,
    grants you, the licensee, a non-exclusive right to use this copy of a
    GV software product.
    GV reserves all rights not  expressly granted to licensee. GV retains
    titleship and ownership  of software.  This license is not  a sale of
    the original  software or any  copy. GV also  retains  titleship  and
    ownership of any modifications or  derivations of this software.  Any
    modifications of this software  must be clearly marked as such.  This
    copyright message must  appear in its entirety  in this software,  or
    any modifications or derivations thereof.
 
    Geovariances welcomes any comments, suggestions, bug reports, etc. At
    the discretion  of Geovariances,  any customer  supplied  bug  fixes,
    enhancements, or utility codes will be distributed in future software
    releases (the contributor will of course be credited).
 
            Geovariances
            38, Avenue Franklin Roosevelt
            77210 Avon, FRANCE
 
             Phone: +33-(0)-160.749.100
               Fax: +33-(0)-164.228.728
            e-mail: support@geovariances.fr
 
                        All Rights Reserved
 
*****************************************************************************/

#ifndef _GTXPacket_h
#define _GTXPacket_h

/* Internal defines */
enum
{
  GTX_PACKET_DATA_NOTHING,
  GTX_PACKET_DATA_STRING,
  GTX_PACKET_DATA_INT,
  GTX_PACKET_DATA_STRING_LIST,
  GTX_PACKET_DATA_DOUBLE,
  GTX_PACKET_DATA_INT_ARRAY,
  GTX_PACKET_DATA_DBL_ARRAY,
  GTX_PACKET_DATA_FILE_INFO,
  GTX_PACKET_DATA_VAR_INFO,
  GTX_PACKET_DATA_DBL_DATA,
  GTX_PACKET_DATA_CHAR_DATA,
  GTX_PACKET_DATA_FAULTS
};

typedef struct
{
  double  test_val;
  double *array;
} GTXdbl_data;

typedef struct
{
  char  *test_val;
  char **list;
} GTXchar_data;

typedef struct
{
  char type[11];
  int  data_type;
  int  size;
  int  tofree;
  union
  {
    char         *vchar;
    int           vint;
    char        **vlist;
    double        vdbl;
    int          *vint_tab;
    double       *vdbl_tab;
    GTXdbl_data   vdbl_data;
    GTXchar_data  vchar_data;
    GTXFileInfo_C     file_info;
    GTXVariableInfo_C var_info;
    GTXFaultSystem_C  fault_system;
  } data;
} GTXPacket;

#endif
